/**
 * Dream
 * Copyright (C) 2003-2004 INRIA Rhone-Alpes
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: dream@objectweb.org
 *
 * Initial developer(s): Matthieu Leclercq
 * Contributor(s): 
 */
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.api.control.IllegalBindingException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;

/**
 * Duplicate calls on service.
 */
public class ServiceDuplicatorImpl implements Service, BindingController
{

  Map services = new HashMap();

  public void print(String msg)
  {
    Iterator iter = services.values().iterator();
    while (iter.hasNext())
    {
      Service serviceItf = (Service) iter.next();
      serviceItf.print(msg);
    }
  }

  public String[] listFc()
  {
    return (String[]) services.keySet().toArray(new String[services.size()]);
  }

  public Object lookupFc(String clientItfName) throws NoSuchInterfaceException
  {
    return services.get(clientItfName);
  }

  public void bindFc(String clientItfName, Object serverItf)
      throws NoSuchInterfaceException, IllegalBindingException,
      IllegalLifeCycleException
  {
    if (clientItfName.startsWith("clientService"))
    {
      services.put(clientItfName, serverItf);
    }
  }

  public void unbindFc(String clientItfName) throws NoSuchInterfaceException,
      IllegalBindingException, IllegalLifeCycleException
  {
    if (clientItfName.startsWith("clientService"))
    {
      services.remove(clientItfName);
    }
  }
}